class Report
  attr_reader :title, :text
  attr_accessor :formatter

  def initialize(&formatter)
    @title = '月次報告'
    @text = ['順調','さいこ〜〜〜']
    @formatter = formatter
  end

  def output_report
    @formatter.call( self )
  end
end

HTMLFormatter = lambda do |context|
    puts '<html>'
    puts ' <head>'
    puts ' <meta charset="UTF-8">'
    puts " <title>#{context.title}</title>"
    puts ' </head>'
    puts ' <body>'
    context.text.each{|line|
      puts(" <p>#{line}</p>")
    }
    puts ' </body>'
    puts '</html>'
end

report = Report.new &HTMLFormatter
report.output_report

#report = Report.new &PlainTextFormatter
report2 = Report.new do|context|
    puts " ***#{context.title}***"
    context.text.each{|line|
      puts(" #{line}\n")
   }
end

report2.output_report


